
#include "ffs.h"

CLASS *FvSys;

int POL_ORD = 0;
void (*ISOFUNC)();
int DOV = 1;

int KOMP = 0;
int NUMBER_OF_KOMPS = 4;

main()

{

FVSYS *fv,*fv_pre,*fv_post;

TIMESCENE *sc1,*sc2;
MANAGER *mgr;
GRAPHICDEVICE *dev;
BUTTON *butt_1;
RULER *rul_komp;
int number_of_timesteps = 10;
char name_of_file[] = "ffsdemo_ffs_sw";
int i,j,stop_flag;

  FvSys = (CLASS *)GRAPE(Adapt2d,"new-class")("fvsys",sizeof(FVSYS));

  GRAPE(FvSys,"add-method")
             ("interpol",fvsys_interpol);
  GRAPE(TimeScene,"add-method")
    ("2dfvsy-switch-isofunc-send",fv_switch_isofunc);
  GRAPE(Ruler,"add-method")("ruler-switch-komp",ruler_switch_komp);

  sc1 = (TIMESCENE *)GRAPE(TimeScene,"new-instance")("fv-out");
  sc2 = (TIMESCENE *)GRAPE(TimeScene,"new-instance")("fv-triang");
  sc2->matrix_flag = G_MATRIX_VIEW;
  sc1->next_scene = (SCENE *)sc2;
  sc2->next_scene = NULL;
  sc1->sync = 1;
  sc2->sync = 1;

  POL_ORD = 0;
  ISOFUNC = isofunc0;
  DOV = 1;

  i = 1;
  stop_flag = NO;
  while ((i < (number_of_timesteps*2)) && (stop_flag != YES)) {

    fv = NULL;
    fv = load(i++,name_of_file,fv);
    fv->refcount = 2;
    if (fv == NULL) stop_flag = YES;
    if (stop_flag != YES) {
      fv->dimension_of_value = DOV;
      fv->polynomial_order = POL_ORD;
      fv->f = ISOFUNC;
      fv_pre = fv;

      fv = NULL;
      fv = load(i++,name_of_file,fv);
      if (fv == NULL) stop_flag = YES;
      if (stop_flag != YES) {
        fv->dimension_of_value = DOV;
        fv->polynomial_order = POL_ORD;
        fv->f = ISOFUNC;
        fv_post = fv;

        sc1->dynamic = (sc1->dynamic == NULL) ?
            (INSTANCE *)GRAPE(TimeStep,"put")(fv_pre,fv_post,fv_post->time) :
            (INSTANCE *)GRAPE(sc1->dynamic,"put")(fv_pre,fv_post,fv->time);
        sc2->dynamic = (sc2->dynamic == NULL) ?
            (INSTANCE *)GRAPE(TimeStep,"put")(fv_pre,fv_post,fv_post->time) :
            (INSTANCE *)GRAPE(sc2->dynamic,"put")(fv_pre,fv_post,fv->time);
        sc1->time = fv_post->time;
        sc2->time = fv_post->time;
      }
    }

  }

  sc1->method_name = (char *)"isoline-disp";
  sc2->method_name = (char *)"deg-fine-disp";

  for (i=0 ; i<4 ; i++)
    for (j=0 ; j<4 ; j++)
      sc2->object_trans[i][j] = (i==j);
    

  sc2->object_trans[0][3] = -0.0;
  sc2->object_trans[1][3] = -0.75;
  sc2->object_trans[2][3] = -0.0;


  butt_1 = (BUTTON *)GRAPE(Button,"new-instance")
      ("2dfvsy-switch-isofunc-send",NIL,"switch isoline");
  rul_komp = (RULER *)GRAPE(Ruler,"new-instance")
      (&KOMP,"output komponent",RULER_INTEGER);

  GRAPE(butt_1,"set-pref-size")(12.0,1.0);
  GRAPE(butt_1,"set-pref-pos")(0.0,2.0);
  GRAPE(butt_1,"set-color-index")(BLUE_COLOR);

  GRAPE(rul_komp,"set-pref-size")(12.0,1.0);
  GRAPE(rul_komp,"set-pref-pos")(0.0,3.0);
  GRAPE(rul_komp,"set-min-max")(0.0,NUMBER_OF_KOMPS+2.0);
  GRAPE(rul_komp,"set-offset")(0.0);
  GRAPE(rul_komp,"set-scale")(10.0);
  GRAPE(rul_komp,"set-step-size")(1.0);
  GRAPE(rul_komp,"set-action")("ruler-switch-komp");

  mgr = (MANAGER*)GRAPE(Manager,"get-stdmgr")();
  dev = (GRAPHICDEVICE *)GRAPE(GraphicDevice,"get-stddev")();

  GRAPE(mgr,"add-inter")(butt_1);
  GRAPE(mgr,"add-inter")(rul_komp);

  mess_out();

  GRAPE(mgr,"handle")(sc1);

}
